(defun c:roof-s ( / *error* lilchk _offset groupbynum unit rlw unioncollinearplaneprints offd inside-p collinear-p collinear-pp unique chkcircinside chkcircinside-dist mc subbody subprocess preprocess prout process osm ape cmd s lw lwi lwx ent enti lil lix el p1 p2 pp ppp ipp ippl vll vlli tll iplst vl vli tl lst ti ) ;;; cad, doc, spc, lay, vlll, vllli, tlll, f - global variables ;;;

  (defun *error* ( m )
    (if (and lwi (not (vlax-erased-p lwi)))
      (entdel lwi)
    )
    (if (and enti (not (vlax-erased-p enti)))
      (entdel enti)
    )
    (if el
      (while (setq el (entnext el))
        (if (and el (not (vlax-erased-p el)))
          (entdel el)
        )
      )
    )
    (if lil
      (progn
        (lilchk)
        (foreach li lil
          (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 3)))
        )
      )
    )
    (if (and lil (setq ppp (unique (mapcar 'car lil))))
      (foreach pp ppp
        (entmake (list (cons 0 "POINT") (cons 10 pp) (cons 62 1)))
      )
    )
    ;;;(command-s "_.-OVERKILL" "_ALL" "_T" "_Y" "" "")
    (if osm
      (setvar 'osmode osm)
    )
    (if ape
      (setvar 'aperture ape)
    )
    (if cmd
      (setvar 'cmdecho cmd)
    )
    (if (= 8 (logand 8 (getvar 'undoctl)))
      (vla-endundomark doc)
    )
    (prompt "\nIf you want to start again on different sample, make sure you nil flag f : (setq f nil vlll nil vllli nil tlll nil lil nil ppp nil lst nil) ...")
    (setq f nil vlll nil vllli nil tlll nil lil nil ppp nil lst nil) ;;; global variables nilled through error handler...
    (if (and m (wcmatch m "*exit*"))
      (princ)
      (if m
        (prompt m)
      )
    )
    (princ)
  )

  (defun lilchk ( / lll ip )
    (setq lll lil)
    (foreach l1 lll
      (setq lll (vl-remove l1 lll))
      (foreach l2 lll
        (if (and (not (equal (car l1) (car l2) 1e-6)) (setq ip (inters (car l1) (cadr l1) (car l2) (cadr l2))) (not (equal (car l1) ip 1e-6)) (not (equal (car l2) ip 1e-6)) (not (equal (cadr l1) ip 1e-6)) (not (equal (cadr l2) ip 1e-6)))
          (setq lil (subst (list ip (cadr l1)) l1 lil) lil (subst (list ip (cadr l2)) l2 lil))
        )
      )
    )
  )

  (defun _offset ( lw dist / lill lww vl lwx tl tln iplst )
    (setq vl (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (setq lwx (entget lw)))))
    (setq tl (mapcar '(lambda ( a b ) (list a b)) vl (append (cdr vl) (list (car vl)))))
    (setq tln (mapcar '(lambda ( x ) (list (polar (car x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)) (polar (cadr x) (+ (* 0.5 pi) (angle (car x) (cadr x))) (- dist)))) tl))
    (setq iplst (mapcar '(lambda ( a b ) (inters (car a) (cadr a) (car b) (cadr b) nil)) tln (append (cdr tln) (list (car tln)))))
    (setq lill (mapcar '(lambda ( a b ) (list a b)) iplst (append (cdr iplst) (list (car iplst)))))
    (setq lill (vl-remove-if '(lambda ( x ) (or (null (car x)) (null (cadr x)))) lill))
    (list
      (entmakex
        (append
          (list
            (cons 0 "LWPOLYLINE")
            (cons 100 "AcDbEntity")
            (cons 100 "AcDbPolyline")
            (cons 90 (length iplst))
            (cons 70 (1+ (* 128 (getvar 'plinegen))))
            (cons 38 0.0)
          )
          (mapcar '(lambda ( p ) (cons 10 p)) iplst)
          (list (list 210 0.0 0.0 1.0))
        )
      )
    )
  )

  (defun groupbynum ( lst n / sub lll )

    (defun sub ( m n / ll q )
      (cond
        ( (and m (< (length m) n))
          (repeat (- n (length m))
            (setq m (append m (list nil)))
          )
          (setq ll (vl-remove-if-not (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m))
          (setq lll (cons ll lll))
          (setq q nil)
          (sub (vl-remove-if (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m) n)
        )
        ( m
          (setq ll (vl-remove-if-not (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m))
          (setq lll (cons ll lll))
          (setq q nil)
          (sub (vl-remove-if (function (lambda ( x ) (setq q (if (not q) 0 (1+ q))) (< q n))) m) n)
        )
        ( t
          (reverse lll)
        )
      )
    )

    (sub lst n)
  )

  (defun unit ( v / d )
    (if (not (equal (setq d (distance '(0.0 0.0 0.0) v)) 0.0 1e-6))
      (mapcar '(lambda ( x ) (/ x d)) v)
    )
  )

  (defun rlw ( lw / e x1 x2 x3 x4 x5 x6 )
    ;; by ElpanovEvgeniy
    (if (= (cdr (assoc 0 (setq e (entget lw)))) "LWPOLYLINE")
      (progn
        (foreach a1 e
          (cond
            ( (= (car a1) 10) (setq x2 (cons a1 x2)) )
            ( (= (car a1) 40) (setq x4 (cons (cons 41 (cdr a1)) x4)) )
            ( (= (car a1) 41) (setq x3 (cons (cons 40 (cdr a1)) x3)) )
            ( (= (car a1) 42) (setq x5 (cons (cons 42 (- (cdr a1))) x5)) )
            ( (= (car a1) 210) (setq x6 (cons a1 x6)) )
            ( t (setq x1 (cons a1 x1)) )
          )
        )
        (entmod
          (append (reverse x1)
            (append
              (apply 'append
                (apply 'mapcar
                  (cons 'list
                    (list x2
                      (cdr (reverse (cons (car x3) (reverse x3))))
                      (cdr (reverse (cons (car x4) (reverse x4))))
                      (cdr (reverse (cons (car x5) (reverse x5))))
                    )
                  )
                )
              )
              x6
            )
          )
        )
        (entupd lw)
      )
    )
  )

  (defun unioncollinearplaneprints ( tl / a b tll )
    (while (setq a (car tl))
      (setq b (vl-remove-if-not (function (lambda ( x ) (and (collinear-pp (car a) (cadr a) (car x)) (collinear-pp (car a) (cadr a) (cadr x))))) tl))
      (setq tll (cons a tll))
      (if b
        (setq tl (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) b))) tl))
        (setq tl (cdr tl))
      )
    )
    tll
  )

  (defun offd ( ip tl / f d dl )

    (defun f ( ip d )
      (if (not (chkcircinside-dist ip d))
        (progn
          (setq dl (vl-remove-if '(lambda ( x ) (equal d x 1e-6)) dl))
          (f ip
            (setq d
              (vl-some
               '(lambda ( x )
                  (if
                    (>
                      (-
                        (length dl)
                        (length (vl-remove-if '(lambda ( y ) (equal x y 1e-5)) dl))
                      ) 2
                    )
                    x
                  )
                ) (vl-sort dl (function >))
              )
            )
          )
        )
        d
      )
    )

    (setq dl
      (mapcar
       '(lambda ( x )
          (distance ip
            (inters
              ip
              (polar ip (+ (* 0.5 pi) (angle (car x) (cadr x))) 1.0)
              (car x)
              (polar (car x) (angle (car x) (cadr x)) 1.0)
              nil
            )
          )
        ) tl
      )
    )
    (setq d
      (vl-some 
       '(lambda ( x )
          (if
            (>
              (-
                (length dl)
                (length (vl-remove-if '(lambda ( y ) (equal x y 1e-5)) dl))
              ) 2
            )
            x
          )
        ) (vl-sort dl (function >))
      )
    )
    (f ip d)
  )

  (defun inside-p ( p lw lwi )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun collinear-p ( p1 p p2 )
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-8)
  )

  (defun collinear-pp ( p1 p2 p3 )
    ( (lambda ( a b c )
        (or
          (equal (+ a b) c 1e-8)
          (equal (+ b c) a 1e-8)
          (equal (+ c a) b 1e-8)
        )
      )
      (distance p1 p2) (distance p2 p3) (distance p1 p3)
    )
  )

  (defun unique ( lst )
    (if lst
      (cons (car lst)
        (unique
          (vl-remove-if
           '(lambda ( x )
              (equal x (car lst) 1e-3)
            )
            (cdr lst)
          )
        )
      )
    )
  )

  (defun chkcircinside ( pp tll / ci ipp ippl params pts tst )
    (if (and pp tll)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 (offd pp tll)))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl))
            (setq pts (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33)))) params)))
            (if (or (not ippl) (vl-every '(lambda ( x ) (inside-p x ent enti)) pts))
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply 'and tst)
  )

  (defun chkcircinside-dist ( pp dist / ci ipp ippl params pts tst )
    (if (and pp dist)
      (progn
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 pp) (cons 40 dist))))
        (if (setq ipp (vlax-invoke (vlax-ename->vla-object ci) 'intersectwith (vlax-ename->vla-object ent) acextendnone))
          (progn
            (while ipp
              (setq ippl (cons (list (car ipp) (cadr ipp)) ippl))
              (setq ipp (cdddr ipp))
            )
            (setq params (mapcar '(lambda ( x ) (vlax-curve-getparamatpoint ci x)) ippl))
            (setq pts (apply 'append (mapcar '(lambda ( x ) (list (vlax-curve-getpointatparam ci (- x 0.33)) (vlax-curve-getpointatparam ci (+ x 0.33)))) params)))
            (if (or (not ippl) (vl-every '(lambda ( x ) (inside-p x ent enti)) pts))
              (setq tst (cons t tst))
              (setq tst (cons nil tst))
            )
          )
          (setq tst (cons t tst))
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (apply 'and tst)
  )

  (defun mc ( ipd lwwnl / ape pll mp lw lwnl ci pl )
    (setq pll (vlax-invoke (vlax-ename->vla-object (car lwwnl)) 'intersectwith (vlax-ename->vla-object (car lwwnl)) acextendnone))
    (setq pll (groupbynum pll 3))
    (setq pll (mapcar '(lambda ( x ) (list (car x) (cadr x))) pll))
    (setq ape (getvar 'aperture))
    (setvar 'aperture 50)
    (setq mp (vl-some '(lambda ( x ) (if (equal (mapcar '+ '(0.0 0.0) (osnap (car ipd) "_end,_int")) x 1e-6) x)) pll))
    (setvar 'aperture ape)
    (if (not mp)
      (progn
        (foreach lww lwwnl
          (if (and lww (not (vlax-erased-p lww)))
            (entdel lww)
          )
        )
        (setq lwnl (_offset ent (- (caddr ipd))) lw (car lwnl))
        (setq ci (entmakex (list (cons 0 "CIRCLE") (cons 10 (car ipd)) (cons 40 0.5))))
        (setq pl (vlax-invoke (vlax-ename->vla-object lw) 'intersectwith (vlax-ename->vla-object ci) acextendnone))
        (setq pl (groupbynum pl 3))
        (setq pl (mapcar '(lambda ( x ) (list (car x) (cadr x))) pl))
        (setq mp (car pl))
        (foreach lw lwnl
          (if (and lw (not (vlax-erased-p lw)))
            (entdel lw)
          )
        )
        (if (and ci (not (vlax-erased-p ci)))
          (entdel ci)
        )
      )
    )
    (list (car ipd) mp)
  )

  (defun subbody ( ipd / n p1 p2 pp1 pp2 ttt d1 d2 fl r pre suf r m o lwnl lwwnl lwwwnl ddl ddm )
    (if (and (car ipd) (cadr ipd) (caddr ipd) (chkcircinside (car ipd) tlll))
      (progn
        (if lil
          (setq n (length lil))
          (setq n 0)
        )
        (if (not (vl-position (list (car ipd) (caadr ipd)) lil))
          (setq lil (cons (list (car ipd) (caadr ipd)) lil))
        )
        (if (not (vl-position (list (car ipd) (cadadr ipd)) lil))
          (setq lil (cons (list (car ipd) (cadadr ipd)) lil))
        )
        (if (= (length lil) (+ n 2))
          (progn
            (setq lwwnl (vl-catch-all-apply 'vlax-invoke (list (vlax-ename->vla-object ent) 'offset (- (+ (caddr ipd) 0.1)))))
            (if (not (vl-catch-all-error-p lwwnl))
              (setq lwwnl (mapcar 'vlax-vla-object->ename lwwnl))
              (exit)
            )
            (setq r nil)
            (if (setq r (mc ipd lwwnl))
              (progn
                (cond
                  ( (and (vl-position (caadr ipd) vll) (vl-position (cadadr ipd) vll))
                    (setq m (min (vl-position (caadr ipd) vll) (vl-position (cadadr ipd) vll)))
                  )
                  ( (vl-position (caadr ipd) vll)
                    (setq m (vl-position (caadr ipd) vll))
                  )
                  ( (vl-position (cadadr ipd) vll)
                    (setq m (vl-position (cadadr ipd) vll))
                  )
                )
                (if m
                  (progn
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vll))) (setq o (1- o))) (= m o)) (reverse vll))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vll))
                    (setq vll (append pre (list (car r)) suf))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vlli))) (setq o (1- o))) (= m o)) (reverse vlli))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vlli))
                    (setq vlli (append pre (list (cadr r)) suf))
                  )
                  (progn
                    (foreach p vll
                      (setq ddl (cons (distance p (car r)) ddl))
                    )
                    (setq ddm (apply 'min ddl))
                    (setq m (vl-position ddm ddl))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vll))) (setq o (1- o))) (= m o)) (reverse vll))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vll))
                    (setq vll (append pre (list (car r)) suf))
                    (setq o nil)
                    (setq pre (reverse (vl-member-if '(lambda ( x ) (if (not o) (setq o (1- (length vlli))) (setq o (1- o))) (= m o)) (reverse vlli))))
                    (setq o nil)
                    (setq suf (vl-member-if '(lambda ( x ) (if (not o) (setq o 0) (setq o (1+ o))) (= m o)) vlli))
                    (setq vlli (append pre (list (cadr r)) suf))                      
                  )
                )
              )
            )
            (foreach lww lwwnl
              (if (and lww (not (vlax-erased-p lww)))
                (entdel lww)
              )
            )
          )
        )
        (if (= (length (vl-remove-if-not '(lambda ( x ) (equal (car ipd) (car x) 1e-6)) lil)) 3)
          (progn
            (setq vll (vl-remove-if '(lambda ( x ) (equal (car r) x 1.0)) vll))
            (setq vlli (vl-remove-if '(lambda ( x ) (equal (cadr r) x 1.0)) vlli))
          )
        )
        (setq vll (vl-remove-if '(lambda ( x ) (equal x (caadr ipd) 1.0)) vll))
        (setq vll (vl-remove-if '(lambda ( x ) (equal x (cadadr ipd) 1.0)) vll))
        (setq vlli (vl-remove-if '(lambda ( x ) (equal x (caadr ipd) 1.0)) vlli))
        (setq vlli (vl-remove-if '(lambda ( x ) (equal x (cadadr ipd) 1.0)) vlli))
        (setq vll (unique vll))
        (setq vlli (unique vlli))
      )
    )
  )

  (defun subprocess ( iplst / iplstoffd ipd ipdl off ) ;;; lst - lexical global variable
    (if (setq iplst (vl-remove-if '(lambda ( x ) (or (not (car x)) (not (cadr x)))) iplst))
      (progn
        (setq iplstoffd
          (mapcar
           '(lambda ( x )
              (if (and (car x) (cadr x))
                (list
                  (mapcar '+ '(0.0 0.0) (car x))
                  (mapcar '(lambda ( y ) (mapcar '+ '(0.0 0.0) y)) (cadr x))
                  (if (setq off (offd (mapcar '+ '(0.0 0.0) (car x)) (unioncollinearplaneprints tlll)))
                    off
                  )
                )
                (list nil nil nil)
              )
            ) iplst
          )
        )
        (setq iplstoffd (vl-sort (vl-remove-if '(lambda ( x ) (not (caddr x))) iplstoffd) '(lambda ( a b ) (> (caddr a) (caddr b)))))
        (foreach ipd iplstoffd
          (if (not (vl-some '(lambda ( x ) (equal x ipd 1e-6)) lst))
            (setq ipdl (cons (list ipd (distance (car ipd) (caadr ipd)) (distance (car ipd) (cadadr ipd)) (caddr ipd)) ipdl))
          )
        )
        (if (not lil)
          (while (setq ipd (caar ipdl))
            (setq ipdl (cdr ipdl))
            (setq lst (cons ipd lst))
            (subbody ipd)
          )
          (progn
            (setq ipdl
              (vl-sort
                (vl-remove-if '(lambda ( x ) (equal (cadddr x) 0.0 0.1)) ipdl)
                 '(lambda ( a b )
                    (if (equal (+ (cadr a) (caddr a)) (+ (cadr b) (caddr b)) 1e-6)
                      (< (min (distance (caar a) (caar lil)) (distance (caar a) (caar lst))) (min (distance (caar b) (caar lil)) (distance (caar b) (caar lst))))
                      (< (+ (cadr a) (caddr a)) (+ (cadr b) (caddr b)))
                    )
                  )
              )
            )
            (setq ipd (caar ipdl))
            (setq lst (cons ipd lst))
            (subbody ipd)
          )
        )
      )
    )
  )

  (defun preprocess ( / iplst )
    (setq iplst
      (mapcar '(lambda ( p1 p2 p3 p4 / ip )
        (if
          (and
            p1 p2 p3 p4
            (setq ip (inters p1 p2 p3 p4 nil))
            (not (equal ip p1 1e-6)) (not (equal ip p2 1e-6)) (not (equal ip p3 1e-6)) (not (equal ip p4 1e-6)) (not (equal p1 p3 1e-6)) (not (equal p2 p4 1e-6)) (not (equal p1 p2 1e-6)) (not (equal p3 p4 1e-6))
            (inside-p ip ent enti)
            (or (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p2 p1)) 0.1) (equal (unit (mapcar '- ip p1)) (unit (mapcar '- p1 p2)) 0.1))
            (or (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p4 p3)) 0.1) (equal (unit (mapcar '- ip p3)) (unit (mapcar '- p3 p4)) 0.1))
            (inside-p (mapcar '+ p1 (mapcar '* (unit (mapcar '- ip p1)) (list 0.1 0.1))) ent enti)
            (inside-p (mapcar '+ p3 (mapcar '* (unit (mapcar '- ip p3)) (list 0.1 0.1))) ent enti)
          )
          (list ip (list p1 p3))
          (list nil nil)
        )
        )
        vll
        vlli
        (append (cdr vll) (list (car vll)))
        (append (cdr vlli) (list (car vlli)))
      )
    )
  )

  (defun prout ( / iplst )
    (setq iplst (preprocess))
    (subprocess iplst)
  )

  (defun process ( / k )
    (setq k 0)
    (while (< (setq k (1+ k)) 50)
      (prout)
    )
  )

  (or cad (progn (vl-load-com) (setq cad (vlax-get-acad-object))))
  (or doc (setq doc (vla-get-activedocument cad)))
  (or spc (setq spc (vla-get-block (setq lay (vla-get-activelayout doc)))))

  (setq osm (getvar 'osmode))
  (setvar 'osmode 0)
  (setq cmd (getvar 'cmdecho))
  (setvar 'cmdecho 0)
  (if (= 8 (logand 8 (getvar 'undoctl)))
    (vla-endundomark doc)
  )
  (vla-startundomark doc)
  (if
    (and
      (princ "\nPick boundary closed polygonal LWPOLYLINE with only straight segments...")
      (setq s (ssget "_+.:E:S" '((0 . "LWPOLYLINE") (-4 . "&") (70 . 1) (-4 . "<not") (-4 . "<>") (42 . 0.0) (-4 . "not>"))))
      (setq lw (ssname s 0))
      (setq ti (car (_vl-times)))
      (= (cdr (assoc 0 (setq lwx (entget lw)))) "LWPOLYLINE")
      (= 1 (logand 1 (cdr (assoc 70 lwx))))
      (vl-every '(lambda ( x ) (= 0.0 (cdr x))) (vl-remove-if '(lambda ( x ) (/= (car x) 42)) lwx))
      (setq el (entlast) ent lw)
    )
    (progn
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -0.01))))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (setq lw (rlw lw)) ;;; force main lwpolyline CCW - counter clockwise ;;;
      )
      (setq enti (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object ent) 'offset -0.01))))
      (if (and lwi (not (vlax-erased-p lwi)))
        (entdel lwi)
      )
      (if (not f) ;;; lil, vll, vlli, tll, ppp, lst - lexical global variables ;;;
        (progn
          (if (not vlll)
            (setq vlll (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget ent))))
          )
          (if (not vllli)
            (setq vllli (mapcar 'cdr (vl-remove-if '(lambda ( x ) (/= (car x) 10)) (entget enti))))
          )
          (if (not tlll)
            (setq tlll (mapcar '(lambda ( a b ) (list a b)) vlll (append (cdr vlll) (list (car vlll)))))
          )
          (setq lil nil vll nil vlli nil tll nil ppp nil lst nil)
          (setq f t)
        )
      )
      (setq vl vlll)
      (if (not vll)
        (setq vll vl)
      )
      (setq vli vllli)
      (if (not vlli)
        (setq vlli vli)
      )
      (setq tl tlll)
      (if (not tll)
        (setq tll tl)
      )
      (vl-cmdf "_.ZOOM" "_OB" ent "")
      (process) ;;; start and finish ...
      (vl-cmdf "_.ZOOM" "_P")
      (prompt "\nElapsed time : ") (princ (rtos (- (car (_vl-times)) ti) 2 20)) (prompt " milliseconds...")
    )
  )
  (*error* nil)
)